﻿Imports Leap
Imports System.Windows.Ink
Public Class ImageInfo
    Public Property 画像名 As String
End Class
Class MainWindow
    Private Declare Function SetCursorPos Lib "user32" (x As Integer, y As Integer) As Boolean
    Private Declare Function apimouse_event Lib "user32" Alias "mouse_event" (ByVal dwFlags As Int32, ByVal dx As Int32, ByVal dy As Int32, ByVal cButtons As Int32, ByVal dwExtraInfo As Int32) As Boolean
    Private Const MOUSEEVENTF_LEFTDOWN = &H2

    Private leap As New Controller
    Private touchIndicator As New DrawingAttributes
    Private touchPoint As StylusPoint

    Private xmldoc As XElement
    Private ImageList As New List(Of ImageInfo)
    Private tx As Double
    Private ty As Double
 
    Private Index As Integer
    Private windowWidth As Double = 1920
    Private windowHeight As Double = 1080

    Private FingersCount As Integer

    Private Sub MainWindow_Loaded(sender As Object, e As RoutedEventArgs) Handles Me.Loaded
        DataShow()
    End Sub

    Private Sub DataShow()
        Dim xmldoc As XElement = XElement.Load("Photo.xml")
        Dim query = From c In xmldoc.Descendants("画像名") Select c

        Dim myImageInfo As New List(Of ImageInfo)

        For Each result In query
            myImageInfo.Add(New ImageInfo With {.画像名 = "Images/" & result.Value})
        Next
        ListBox1.ItemsSource = myImageInfo

        AddHandler CompositionTarget.Rendering, AddressOf Update
        touchIndicator.Width = 15
        touchIndicator.Height = 15

        touchIndicator.StylusTip = StylusTip.Ellipse
    End Sub

    Private Sub Update(sender As Object, e As EventArgs)
        paintCanvas.Strokes.Clear()
        windowWidth = Me.Width
        windowHeight = Me.Height

        Dim frame As Leap.Frame = leap.Frame
        Dim interactionBox As InteractionBox = leap.Frame.InteractionBox

        For Each Pointable As Pointable In leap.Frame.Pointables
            Dim normalizedPosition As Leap.Vector = interactionBox.NormalizePoint(Pointable.StabilizedTipPosition)

            tx = normalizedPosition.x * windowWidth
            ty = windowHeight - normalizedPosition.y * windowHeight

            touchPoint = New StylusPoint(tx, ty)

            Dim tips As New StylusPointCollection(New StylusPoint() {touchPoint})
            Dim touchStroke As New Stroke(tips, touchIndicator)
            paintCanvas.Strokes.Add(touchStroke)

            'ホーバー
            If Pointable.TouchDistance > 0 AndAlso Pointable.TouchZone <> Global.Leap.Pointable.Zone.ZONENONE Then
                touchIndicator.Color = Colors.Blue

                FingersCount = leap.Frame.Fingers.Count
                'タッチ
            ElseIf Pointable.TouchDistance <= 0 Then

                touchIndicator.Color = Colors.Red
                If FingersCount = 1 Then
                    SetCursorPos(touchPoint.X, touchPoint.Y)
                    apimouse_event(MOUSEEVENTF_LEFTDOWN, 0, 0, 0, 0)
                End If

                If FingersCount = 5 Then
                    DataShow()
                End If
                'タッチ対象外
            Else
                touchIndicator.Color = Colors.Gold
            End If
        Next

    End Sub
End Class
